diff --git a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
index 7689e475a..c1b375e69 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -15,6 +15,7 @@ import net.minecraft.client.util.helper.Buffer;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
@@ -160,7 +161,7 @@ public class LightmapHelper {
 		}
 	}
 	
-	public void generateColorizedLightmap(World world, float partialTicks) {
+	public void generateColorizedLightmap(@NotNull World world, float partialTicks) {
 		float ambientBrightness = world.getAmbientBrightness(partialTicks);
 		float brightness = GameSettings.BRIGHTNESS.value - 0.5f;
 
@@ -204,7 +205,7 @@ public class LightmapHelper {
 		}
 	}
 	
-	public void generateCustomLightmap(World world) {
+	public void generateCustomLightmap(@NotNull World world) {
 		float ambientBrightness = (world.getAmbientBrightness(1.0f) - 0.2f) / 0.8f;
 		float brightness = GameSettings.BRIGHTNESS.value;
 		
@@ -248,7 +249,7 @@ public class LightmapHelper {
 //		}
 	}
 
-	public void setLightmapTextureData(int[] data) {
+	public void setLightmapTextureData(int @NotNull [] data) {
 		OpenGLHelper.checkError("pre set lightmap data");
 
 		Buffer.checkBufferSize(16 * 16 * 4);
@@ -296,69 +297,10 @@ public class LightmapHelper {
 		return color * (1.0f - gamma) + color2 * gamma;
 	}
 
-	public float getBrightnessRemoveMinLight(World world, int i) {
+	public float getBrightnessRemoveMinLight(@NotNull World world, int i) {
 		float brightness = world.worldType.getBrightnessRamp()[i];
 		float min = 0.05f;
 
 		return (brightness - min) / (1.0f - min);
 	}
-
-	public static int getLightmapCoord(int skylight, int blocklight) {
-		return skylight << 20 | blocklight << 4;
-	}
-
-	public static int getLightmapCoord(float skylight, float blocklight) {
-		return getLightmapCoord((int) (0xF * skylight), (int) (0xF * blocklight));
-	}
-	
-	public static int getOverbrightLightmapCoord(int skylight) {
-		return getLightmapCoord(skylight, 15);
-	}
-	
-	public static int max(int lightmapCoord1, int lightmapCoord2) {
-		int sky1 = lightmapCoord1 >> 16;
-		int sky2 = lightmapCoord2 >> 16;
-		
-		int block1 = lightmapCoord1 & 0xFFFF;
-		int block2 = lightmapCoord2 & 0xFFFF;
-		
-		return Math.max(sky1, sky2) << 16 | Math.max(block1, block2);
-	}
-	
-	public static int avg(int lmc0, int lmc1) {
-		int sky0 = lmc0 >> 16;
-		int sky1 = lmc1 >> 16;
-		
-		int block0 = lmc0 & 0xFFFF;
-		int block1 = lmc1 & 0xFFFF;
-		
-		int sky = (sky0 + sky1) >> 1;
-		int block = (block0 + block1) >> 1;
-		
-		return sky << 16 | block;
-	}
-	
-	public static int avg(int lmc0, int lmc1, int lmc2, int lmc3) {
-//		int lmc01 = (lmc0 + lmc1) >> 1;
-//		int lmc23 = (lmc2 + lmc3) >> 1;
-//		return (lmc01 + lmc23) >> 1;
-		return avg(avg(lmc0, lmc1), avg(lmc2, lmc3));
-	}
-	
-	public static int setBlocklightValue(int lightmapCoord, int blocklight) {
-		return lightmapCoord & 0xFFFF0000 | blocklight << 4;
-	}
-
-	public static int getBlockLightFromCoord(int lightmapCoord) {
-		return  ((lightmapCoord) & 0xFFFF) >> 4;
-	}
-	
-	public static int setSkylightValue(int lightmapCoord, int skylight) {
-		return lightmapCoord & 0x0000FFFF | skylight << 20;
-	}
-
-	public static int getSkyLightFromCoord(int lightmapCoord) {
-		return  (lightmapCoord & 0xFFFF0000) >> 20;
-	}
-
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
index 131e4ddf2..d27048aa6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
@@ -6,8 +6,12 @@ import net.minecraft.core.Global;
 import net.minecraft.core.enums.EnumOS;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.ARBFramebufferObject;
+import org.lwjgl.opengl.ATIMeminfo;
 import org.lwjgl.opengl.GL41;
 import org.lwjgl.opengl.GLCapabilities;
+import org.lwjgl.opengl.NVXGPUMemoryInfo;
+import org.lwjgl.system.MemoryStack;
+import org.lwjgl.system.MemoryUtil;
 import org.slf4j.Logger;
 
 import java.util.HashSet;
@@ -21,18 +25,24 @@ public class OpenGLHelper {
     public static int[] versionPairs = new int[] {4, 6, 4, 3, 4, 1};
 
     public static boolean contextCreated = false;
-    public static boolean gl46 = false;
-    public static boolean gl43 = false;
+    public static GLCapabilities capabilities;
 
     public static @NotNull String version = "Unknown";
     public static @NotNull String vendor = "Unknown";
     public static @NotNull String renderer = "Unknown";
 
+    public static int major = 0;
+    public static int minor = 0;
+
+    private static int ATI_STARTING_FREE_AMOUNT = 0;
+
     public static void testCapabilities(@NotNull GLCapabilities capabilities) {
         contextCreated = true;
         LOGGER.info("");
         LOGGER.info("=== GPU VENDOR INFO ===");
-        LOGGER.info("OpenGL {}.{}", GL41.glGetInteger(GL41.GL_MAJOR_VERSION), GL41.glGetInteger(GL41.GL_MINOR_VERSION));
+        major = GL41.glGetInteger(GL41.GL_MAJOR_VERSION);
+        minor = GL41.glGetInteger(GL41.GL_MINOR_VERSION);
+        LOGGER.info("OpenGL {}.{}", major, minor);
 
         version = Objects.requireNonNullElse(GL41.glGetString(GL41.GL_VERSION), "Query Failure");
         vendor = Objects.requireNonNullElse(GL41.glGetString(GL41.GL_VENDOR), "Query Failure");
@@ -44,20 +54,52 @@ public class OpenGLHelper {
 
         LOGGER.info("");
 
-        LOGGER.info("GL_ARB_framebuffer_object: {}", capabilities.GL_ARB_framebuffer_object);
-        LOGGER.info("GL_ARB_occlusion_query: {}", capabilities.GL_ARB_occlusion_query);
-        LOGGER.info("GL_NV_fog_distance: {}", capabilities.GL_NV_fog_distance);
-
-        gl43 = capabilities.OpenGL43;;
-        gl46 = capabilities.OpenGL46;
+        OpenGLHelper.capabilities = capabilities;
 
         if (!capabilities.OpenGL41) {
             if (Minecraft.getOs() == EnumOS.macos) {
-                LOGGER.warn("BTA Requires OpenGL4.1 but only {} was found! If you're on MacOS this is probably just Apple misreporting the GLVersion number and not actually due to a lack of support.", GL41.glGetString(GL41.GL_VERSION));
+                LOGGER.warn("BTA Requires OpenGL4.1 but only {} was found! If you're on MacOS this is probably just Apple misreporting the GLVersion number and not actually due to a lack of support.", version);
             } else {
-                LOGGER.error("BTA Requires OpenGL4.1 but only {} was found!", GL41.glGetString(GL41.GL_VERSION));
+                LOGGER.error("BTA Requires OpenGL4.1 but only {} was found!", version);
+            }
+        }
+
+        if (capabilities.GL_ATI_meminfo) {
+            try(var stack = MemoryStack.stackPush()) {
+                var intBuff = stack.mallocInt(4);
+                GL41.glGetIntegerv(ATIMeminfo.GL_VBO_FREE_MEMORY_ATI, intBuff);
+                ATI_STARTING_FREE_AMOUNT = intBuff.get(0);
+            }
+
+        }
+    }
+
+    /**
+     * @return Total amount of VRam (or VBO space) the GPU has in KB
+     */
+    public static long totalVRam() {
+        if (capabilities.GL_NVX_gpu_memory_info) {
+            return GL41.glGetInteger(NVXGPUMemoryInfo.GL_GPU_MEMORY_INFO_DEDICATED_VIDMEM_NVX);
+        } else if (capabilities.GL_ATI_meminfo) {
+            return ATI_STARTING_FREE_AMOUNT;
+        }
+        return -1;
+    }
+
+    /**
+     * @return Amount of Available VRam (or VBO space) in KB
+     */
+    public static long availableVRam() {
+        if (capabilities.GL_NVX_gpu_memory_info) { // https://registry.khronos.org/OpenGL/extensions/NVX/NVX_gpu_memory_info.txt
+            return GL41.glGetInteger(NVXGPUMemoryInfo.GL_GPU_MEMORY_INFO_CURRENT_AVAILABLE_VIDMEM_NVX);
+        } else if (capabilities.GL_ATI_meminfo) { // Unsure if implemented correctly, ATI's extension kinda sucks https://registry.khronos.org/OpenGL/extensions/ATI/ATI_meminfo.txt
+            try(var stack = MemoryStack.stackPush()) {
+                var intBuff = stack.mallocInt(4);
+                GL41.glGetIntegerv(ATIMeminfo.GL_VBO_FREE_MEMORY_ATI, intBuff);
+                return intBuff.get(0);
             }
         }
+        return -1;
     }
 
     public static void checkError(String info) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 6f3fa2e70..4084cc71b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -22,6 +22,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBdc;
+import org.lwjgl.opengl.GL41;
 
 import java.util.List;
 import java.util.Random;
@@ -87,7 +88,14 @@ public final class ParticleEngine {
      */
     public void renderParticles(@NotNull ICamera camera, float partialTick) {
         GLRenderer.pushFrame();
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
         GLRenderer.setShader(Shaders.PARTICLE);
+        GL41.glActiveTexture(GL41.GL_TEXTURE2);
+        TextureRegistry.worldAtlas.layerTextureMap.get("emissive").bind();
+        GL41.glActiveTexture(GL41.GL_TEXTURE3);
+        TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
+        GL41.glActiveTexture(GL41.GL_TEXTURE0);
+        TextureRegistry.worldAtlas.bind();
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.enableState(State.DEPTH_TEST);
@@ -103,7 +111,6 @@ public final class ParticleEngine {
             if (this.particles[tt].isEmpty()) {
                 continue;
             }
-            TextureRegistry.worldAtlas.bind();
             tessellator.setTranslation(-xOff, -yOff, -zOff);
             tessellator.startDrawingParticles();
             for (int i = 0; i < this.particles[tt].size(); i++) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index f96016852..66a3c52f8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -264,7 +264,7 @@ public class RenderGlobal
         this.zMaxChunk = this.zChunks;
 
         for (ChunkRenderer cr : this.dirtyChunks) {
-            cr.dirty = false;
+            cr.setDirty(false);
         }
 
         this.dirtyChunks.clear();
@@ -277,7 +277,7 @@ public class RenderGlobal
                     this.chunkRenderers[index] = this.mc.terrainRenderer.createChunkRenderer(this.world, this.renderableTileEntities, x * RENDER_CHUNK_SIZE, y * RENDER_CHUNK_SIZE, z * RENDER_CHUNK_SIZE, RENDER_CHUNK_SIZE);
                     this.chunkRenderers[index].visible = true;
                     this.chunkRenderers[index].id = count++;
-                    this.chunkRenderers[index].setDirty();
+                    this.chunkRenderers[index].setDirty(true);
                     this.dirtyChunks.add(this.chunkRenderers[index]);
                     id += ChunkRenderer.MAX_RENDER_PASSES + 1;
                 }
@@ -606,9 +606,9 @@ public class RenderGlobal
                     }
 
                     ChunkRenderer renderer = this.chunkRenderers[(z * this.yChunks + y) * this.xChunks + x];
-                    boolean wasDirty = renderer.dirty;
+                    boolean wasDirty = renderer.isDirty();
                     renderer.setPos(xx, yy, zz);
-                    if (!wasDirty && renderer.dirty) {
+                    if (!wasDirty && renderer.isDirty()) {
                         this.dirtyChunks.add(renderer);
                     }
                 }
@@ -624,7 +624,7 @@ public class RenderGlobal
         for (int i = 0; i < 10; i++) {
             this.chunkFixOffs = (this.chunkFixOffs + 1) % this.chunkRenderers.length;
             ChunkRenderer chunkRenderer = this.chunkRenderers[this.chunkFixOffs];
-            if (chunkRenderer.dirty && !this.dirtyChunks.contains(chunkRenderer)) {
+            if (chunkRenderer.isDirty() && !this.dirtyChunks.contains(chunkRenderer)) {
                 this.dirtyChunks.add(chunkRenderer);
             }
         }
@@ -1125,7 +1125,7 @@ public class RenderGlobal
             }
             for (ChunkRenderer renderer : this.nearChunks) {
                 if (renderer.rebuild(true)) {
-                    renderer.dirty = false;
+                    renderer.setDirty(false);
                     this.dirtyChunks.remove(renderer);
                 }
             }
@@ -1141,7 +1141,7 @@ public class RenderGlobal
                 break;
             }
             if (chunkx.rebuild(false)) {
-                chunkx.dirty = false;
+                chunkx.setDirty(false);
                 this.dirtyChunks.remove(chunkx);
             }
         }
@@ -1169,7 +1169,7 @@ public class RenderGlobal
             tessellator.setTranslation(-x, -y, -z);
             tessellator.lockColor();
             // Make sure it's active to prevent crash if a model doesnt enable it
-            tessellator.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 0));
+            tessellator.setLightmapCoord2i(15, 0);
             BlockModelDispatcher.getInstance()
                 .getDispatch(block)
                 .renderWithOverrideTexture(
@@ -1783,9 +1783,9 @@ public class RenderGlobal
                     int p = (zz * this.yChunks + yy) * this.xChunks + xx;
 
                     ChunkRenderer renderer = this.chunkRenderers[p];
-                    if (!renderer.dirty) {
+                    if (!renderer.isDirty()) {
                         this.dirtyChunks.add(renderer);
-                        renderer.setDirty();
+                        renderer.setDirty(true);
                     }
                 }
             }
@@ -1864,9 +1864,9 @@ public class RenderGlobal
         }
         if (seasonChanged) {
             for (ChunkRenderer chunkRenderer : this.chunkRenderers) {
-                if (/*chunkRenderer.skyLit && */!chunkRenderer.dirty) {
+                if (/*chunkRenderer.skyLit && */!chunkRenderer.isDirty()) {
                     this.dirtyChunks.add(chunkRenderer);
-                    chunkRenderer.setDirty();
+                    chunkRenderer.setDirty(true);
                 }
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 7f7548571..6aaf4e042 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -649,8 +649,8 @@ public class WorldRenderer {
         GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
         GL41.glActiveTexture(GL41.GL_TEXTURE2);
         TextureRegistry.worldAtlas.layerTextureMap.get("emissive").bind();
-//        GL41.glActiveTexture(GL41.GL_TEXTURE3);
-//        TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
+        GL41.glActiveTexture(GL41.GL_TEXTURE3);
+        TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
         GL41.glActiveTexture(GL41.GL_TEXTURE0);
         Lighting.enableLight();
         GLRenderer.setShader(Shaders.TERRAIN);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index d16c5cbda..1ae54ebbe 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -24,7 +24,7 @@ public abstract class BlockModel<T extends BlockLogic> {
     public abstract boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
     public abstract boolean renderNoCulling(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
     public abstract boolean renderWithOverrideTexture(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate overrideTexture);
-    public abstract void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord);
+    public abstract void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex);
 
     public abstract boolean shouldItemRender3d();
     public abstract @NotNull DisplayPos getItemDisplayPos(@NotNull String id);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index 16b5112a7..b510836da 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -16,7 +16,7 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         // Used for the rendering for the block inside the jar
         final float yOffset = 0.0F;
 
@@ -32,7 +32,7 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
         tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
         tessellator.setColor1i(getStandaloneTintColor(metadata));
-        tessellator.setLightmapCoord1i(lightmapCoord);
+        tessellator.setLightmapCoord1i(lightIndex);
 
         double xd = 0;
         double yd = 0;
@@ -67,7 +67,7 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
 
     @Override
     public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
-        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        tessellator.setLightmapCoord1i(this.block.getLightIndex(worldSource, tilePos));
 
         int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
         float r = (float) (color >> 16 & 0xff) / 255F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 7684fd75a..babac5c11 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -267,10 +267,10 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.PUMICE_DRY, loadDataModel("minecraft:block/pumice")));
         addDispatch(new BlockModelGeneric<>(Blocks.PUMICE_WET, loadDataModel("minecraft:block/pumice_wet")));
 
-        addDispatch(new BlockModelGeneric<>(Blocks.MOSS_STONE, loadDataModel("minecraft:block/stone_mossy")));
-        addDispatch(new BlockModelGeneric<>(Blocks.MOSS_BASALT, loadDataModel("minecraft:block/basalt_mossy")));
-        addDispatch(new BlockModelGeneric<>(Blocks.MOSS_LIMESTONE, loadDataModel("minecraft:block/limestone_mossy")));
-        addDispatch(new BlockModelGeneric<>(Blocks.MOSS_GRANITE, loadDataModel("minecraft:block/granite_mossy")));
+        addDispatch(new BlockModelGeneric<>(Blocks.MOSS_STONE, loadDataModel("minecraft:block/moss/stone")));
+        addDispatch(new BlockModelGeneric<>(Blocks.MOSS_BASALT, loadDataModel("minecraft:block/moss/basalt")));
+        addDispatch(new BlockModelGeneric<>(Blocks.MOSS_LIMESTONE, loadDataModel("minecraft:block/moss/limestone")));
+        addDispatch(new BlockModelGeneric<>(Blocks.MOSS_GRANITE, loadDataModel("minecraft:block/moss/granite")));
 
         addDispatch(new BlockModelGeneric<>(Blocks.SAND, loadDataModel("minecraft:block/sand")));
         addDispatch(new BlockModelGeneric<>(Blocks.GRAVEL, loadDataModel("minecraft:block/gravel")));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index da9386924..2f7d22214 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
@@ -19,7 +18,7 @@ public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard
 
     @Override
     public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
-        tessellator.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
+        tessellator.setLightmapCoord2i(15, 15);
         tessellator.setColorOpaque3f(1.0f, 1.0f, 1.0f);
 
         AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
index c15c7c70e..46e414d49 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
@@ -21,7 +21,7 @@ public class BlockModelEmpty<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public void renderStandalone(@NotNull final TessellatorGeneral tessellator, final int metadata, final int lightmapCoord) {
+    public void renderStandalone(@NotNull final TessellatorGeneral tessellator, final int metadata, final byte lightIndex) {
 
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 4393cbb2e..367a8d321 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -74,7 +74,7 @@ public class BlockModelFence<T extends BlockLogicFence> extends BlockModelStanda
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
         tessellator.setColor1i(getStandaloneTintColor(metadata));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
index 32255f8bc..f0046ca14 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
@@ -156,7 +156,7 @@ public class BlockModelFenceGate<T extends BlockLogicFenceGate> extends BlockMod
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
         tessellator.setColor1i(getStandaloneTintColor(metadata));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index 137361f9e..d3a361a8e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -36,7 +36,7 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
     @Override
     public boolean render(@NotNull TessellatorGeneral t, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        t.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        t.setLightmapCoord1i(this.block.getLightIndex(worldSource, tilePos));
         t.setColorOpaque3f(brightness, brightness, brightness);
 
         TilePos queryPos = new TilePos();
@@ -327,7 +327,7 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         int color = getStandaloneTintColor(metadata);
         GLRenderer.modelM4f().rotateY(Math.toRadians(90));
         AABBd bounds = new AABBd(0, 0, 0, 1, 1, 1);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index ebf152822..20231603c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.world.WorldClient;
@@ -32,7 +31,7 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
         if (renderBlocks.overrideBlockTexture != null) {
             tex = renderBlocks.overrideBlockTexture;
         }
-        tessellator.setLightmapCoord1i(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos)));
+        tessellator.setLightmapCoord2i(worldSource.getSavedLightValue(LightLayer.Sky, tilePos), 15);
         double uMin = tex.getIconUMin();
         double uMax = tex.getIconUMax();
         double vMin = tex.getIconVMin();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 695e768c9..1d7e5ed30 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
@@ -8,7 +7,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.Materials;
-import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
@@ -16,8 +15,6 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
 import org.joml.Vector3d;
-import org.joml.Vector3dc;
-import org.joml.Vector3f;
 import org.joml.primitives.AABBdc;
 
 public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStandard<T> {
@@ -71,10 +68,10 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             } else {
                 rotation = 0.0F;
             }
-            int light = this.block.getLightmapCoord(worldSource, tilePos);
-            int lightUp = this.block.getLightmapCoord(worldSource, tilePos.up(queryPos));
+            byte light = this.block.getLightIndex(worldSource, tilePos);
+            byte lightUp = this.block.getLightIndex(worldSource, tilePos.up(queryPos));
 
-            tessellator.setLightmapCoord1i(LightmapHelper.max(light, lightUp));
+            tessellator.setLightmapCoord1i(LightIndexHelper.max(light, lightUp));
             if (tex.namespaceId.toString().contains("_flowing")) {
                 float cos = Math.cos(-rotation + Math.PI_OVER_2_f);
                 float sin = Math.sin(-rotation + Math.PI_OVER_2_f);
@@ -115,7 +112,7 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
 
         }
         if (renderBlocks.renderAllFaces || flag1) {
-            tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos.down(queryPos)));
+            tessellator.setLightmapCoord1i(this.block.getLightIndex(worldSource, tilePos.down(queryPos)));
             tessellator.setNormal(0, -1, 0);
             renderBlocks.renderBottomFace(tessellator, bounds, x, y + yOff, z, getBlockTextureFromSideAndMetadata(Side.TOP, 0));
             didRender = true;
@@ -179,7 +176,7 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             double v1 = texture.getSubIconV(0.5F - f13 / 2);
             double v2 = texture.getSubIconV(0.5F - f15 / 2);
             double v3 = texture.getSubIconV(0.5F);
-            tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, posB));
+            tessellator.setLightmapCoord1i(this.block.getLightIndex(worldSource, posB));
             switch (side) {
                 case 0 -> tessellator.setNormal(0, 0, -1);
                 case 1 -> tessellator.setNormal(0, 0, 1);
